/*!
 * `deployr` JavaScript Client Library v7.4.2
 * http://deployr.revolutionanalytics.com/documents/dev/client-jsdoc
 *
 * Copyright (C) 2010-2015 by Revolution Analytics Inc.
 * Released under the Apache License 2.0
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Includes:
 *   - superagent: https://github.com/visionmedia/superagent
 *   - ws: https://github.com/einaros/ws
 *   - D.js: http://malko.github.io/D.js
 *   - yui-lang.js: https://github.com/yui/yui3 (DeployR port)
 *
 * superagent
 *
 * Copyright (c) 2014-2015 TJ Holowaychuk <tj@vision-media.ca>
 * Open Source Initiative OSI - The MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the,
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * ws
 *
 * Copyright (c) 2011 Einar Otto Stangvik <einaros@gmail.com>
 * Open Source Initiative OSI - The MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining 
 * a copy of this software and associated documentation files 
 * (the "Software"), to deal in the Software without restriction, 
 * including without limitation the rights to use, copy, modify, merge
 * publish, distribute, sublicense, and/or sell copies of the Software, 
 * and to permit persons to whom the Software is furnished to do so, 
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be 
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * D
 *
 * Copyright (C) 2013 Jonathan Gotti <jgotti at jgotti dot net>
 * Open Source Initiative OSI - The MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the,
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * selfish
 *
 * Copyright 2011 Irakli Gozalishvili. All rights reserved
 * Open Source Initiative OSI - The MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the,
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * yui-lang
 *
 * The lang component is a DeployR port of yui-lang.js by Yahoo!
 *
 * Software License Agreement (BSD License)
 * Copyright (c) 2013, Yahoo! Inc. All rights reserved.
 *
 * Redistribution and use of this software in source and binary forms, 
 * with or without modification, are permitted provided that the 
 * following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer. Redistributions
 * in binary form must reproduce the above copyright notice, this list of
 * conditions and  the following disclaimer in the documentation and/or 
 * other materials provided with the distribution.
 * 
 * Neither the name of Yahoo! Inc. nor the names of YUI's contributors 
 * may be used to endorse or promote products derived from this software 
 * without specific prior written permission of Yahoo! Inc.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT, 
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Date: 2015-07-27
 */
!function(t){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=t();else if("function"==typeof define&&define.amd)define([],t);else{var e;e="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this,e.deployr=t()}}(function(){var t;return function e(t,r,o){function i(s,a){if(!r[s]){if(!t[s]){var c="function"==typeof require&&require;if(!a&&c)return c(s,!0);if(n)return n(s,!0);var u=new Error("Cannot find module '"+s+"'");throw u.code="MODULE_NOT_FOUND",u}var l=r[s]={exports:{}};t[s][0].call(l.exports,function(e){var r=t[s][1][e];return i(r?r:e)},l,l.exports,e,t,r,o)}return r[s].exports}for(var n="function"==typeof require&&require,s=0;s<o.length;s++)i(o[s]);return i}({1:[function(t,e,r){(function(r){function o(t,e){var r=e.deployr?e.deployr.response.errorCode:e.status,o=this;j.events&&(e.deployr||(e=e.text),o=j.events.ctx||o,j.events.error&&j.events.error.apply(o,[t,e]),j.events[r]&&j.events[r].apply(o,[t,e]))}var i="undefined"!=typeof window,n=t("superagent"),s=t("d.js"),a=t("fs"),c=t("./apis.json"),u=t("./lib/es"),l=t("./lib/utils"),p=t("./lib/lang"),h=t("./lib/logger"),f=t("./lib/queue"),d=t("./lib/emitter"),y=t("./lib/encoder"),m=t("./lib/selfish").Base,v=t("./lib/rinput"),R=t("./lib/rinputs"),g=l.merge;h.setLevel(h.OFF);var j={cors:!1,logging:!1,sticky:!1,cookies:null,host:"",allowSelfSignedSSLCert:!1,maxRequests:null,events:{},set:function(t,e){"set"!==t&&("host"===t&&e&&(e=e.replace(/\/*$|\/*deployr\/*$/,""),e=new RegExp("^(http|https)://","i").test(e)?e:"http://"+e),this[t]=e)}},T=["user","project","workspace","execution","directory","repository","packages"],E=m.extend(d,R,{initialize:function(t,e){d.initialize.call(this,{});var o=j;if(!c[t])throw new Error('Invalid API "'+t+'"');this.api=g({call:t},c[t]),this.link=e||{},this.q=this.link.queue||new f,this.deferred=this.link.deferred||s(),this.cookies=this.link.cookies,this.logger=h.get(t,h.OFF),this.params={},this.inputs=[],this.outputs=[],this.rstream=!1,this.delayed=!1,this.globalEvts=!0,this.file=null,this.entities=null,this.ioFilter=function(){return!0},this.data({format:this.api.format}),this.req=n[this.api.method.toLowerCase()](o.host+"/deployr"+t),this.req.timeout(12e5),i&&j.cors&&this.req.withCredentials(),!i&&j.allowSelfSignedSSLCert&&(r.env.NODE_TLS_REJECT_UNAUTHORIZED="0")},ctx:function(t){return this.scope=t||this,this},global:function(t){return this.globalEvts=p.isBoolean(t)?t:this.globalEvts,this},about:function(){var t=this.req.res;return"/r/user/login"===this.api.call&&t?t.body.get("user"):null},share:function(t){return j.sticky?j.cookies?this.cookies=j.cookies.slice(0):t&&(this.cookies=t.slice(0),j.set("cookies",this.cookies)):this.cookies=t?t.slice(0):this.cookies,this},getCookies:function(){return this.cookies},delay:function(t){return this.delayed=!isNaN(parseFloat(t))&&isFinite(t)?t:!0,this},drain:function(){return this.delayed=!1,this.q.flush(),this.deferred.promise},promise:function(){return this.end(),this.deferred.promise},abort:function(){return this.req.abort(),this.emit("abort"),this.deferred.reject(this._handleError({status:"abort",text:"DeployR request aborted."})),this},timeout:function(t){return this.req.timeout(t),this},log:function(t){return this.logger.setLevel(t||h.DEBUG),this},entity:function(t){return this.entities=l.inArray(T,t),this},data:function(t){t=t||{},(t.rinput||t.rinputs)&&(this.rinput(t.rinput),this.rinputs(t.rinputs));var e=["rinput","rinputs","__cookies__"];return e.forEach(function(e){delete t[e]}),this.params=g(this.params,t),this},attach:function(t,e){return this.api.upload&&(this.file=t,e&&this.data({filename:e})),this},stream:function(){return this.rstream=!i&&this.api.upload,this},filter:function(t){return t&&(this.ioFilter=function(e){var r,o={};for(var i in e)"__cookies__"!==i&&(o[i]=e[i]);return r=t(o),r||r===!1?r:!0}),this},ensure:function(t){return this.deferred.promise.ensure(t),this.deferred.promise},error:function(t){return this.on("error",t),this},pipe:function(t){var e=this.q,r=this.api;return e.add(function(o,i,n){if(i)return this.deferred.reject(i),e.flush(o,i,n),void this._clear();this._prepRequest(o,n),h.info("pipe()",r,this.req),this.logger.info("pipe()",r,this.req);var s=this.req.pipe(t);e["yield"](!0),s.on("error",function(){}),s.on("end",function(){}),s.on("data",function(){})},this),e.size()<=1&&e.flush(),t},end:function(t){var e=this,r=this.q,o=this.api,i=null,n=this.entities;return r.add(function(s,a,c){return a?(this.deferred.reject(a),r.flush(s,a,c),void this._clear()):this.ioFilter(c)?(this._prepRequest(s,c),h.info("io()",o,this.req),this.logger.info("io()",o,this.req),this.req.end(function(c){e.share(e.cookies||c.headers["set-cookie"]),e.cookies&&(h.info("cookies",o,e.cookies),e.logger.info("cookies",o,e.cookies)),a=e._handleError(c);var u=c.body&&c.body.deployr?c.body:c;e.inputs=[],e.outputs=[],a||(h.info("end()",o,u,c),e.logger.info("end()",o,u,c),n&&(u=u.deployr.response[n]||u),u.get=function(t){return l.get(u.deployr.response,t)},u.workspace=function(t){return l.workspace(u.deployr.response,t)},t&&(i=t.apply(e.scope,[u,s])),0===r.size()&&(e._clear(),e.deferred.resolve(s||u)),i=g(i,{__cookies__:e.cookies})),r["yield"](!1),r.flush(u,a,i)}),void r["yield"](!0)):(0===r.size()&&this.deferred.resolve(s||c),r.flush(s,a,c),void this._clear())},this,this.delayed),!this.delayed&&r.size()<=1&&r.flush(),this},io:function(t){return E["new"](t,{cookies:this.cookies,queue:this.q,deferred:this.deferred})},script:function(){var t=l.signature(arguments),e=t.opts,r=t.api,o={cookies:this.cookies,queue:this.q,deferred:this.deferred};return t.create?E["new"]("/r/project/create",o).end(function(t){return{project:t.get("project").project}}).io(r).data(e):E["new"](r,o).data(e)},shell:function(t,e){var r={cookies:this.cookies,queue:this.q,deferred:this.deferred},o=p.isString(t)?t.split("/"):[];return o.length>3&&(o=o.slice(1)),E["new"]("/r/repository/shell/execute",r).data({author:o[0],directory:o[1],filename:o[2],args:e})},code:function(t,e){var r={cookies:this.cookies,queue:this.q,deferred:this.deferred},o="/r/project/execute/code";return e?E["new"](o,r).data({code:t,project:e}):E["new"]("/r/project/create",r).end(function(t){return{project:t.get("project").project}}).io(o).data({code:t})},release:function(t,e){function r(t){t===c&&(e?(i.resolve(!0),o.destroy()):E["new"]("/r/user/logout").share(u).error(function(){i.reject(!1)}).end(function(){i.resolve(!0)}).ensure(function(){o.destroy()}))}t=p.isArray(t)?t:[t];var o=this,i=s(),n=!t||!t[0],a=0,c=n?a:t.length-1,u=this.getCookies();return n?r(a):t.forEach(function(t){E["new"]("/r/project/close").data({project:t}).share(u).end().ensure(function(){r(a),a++})}),i.promise},routputs:function(t){return t&&(this.outputs=this.outputs.concat(t)),this},routput:function(t){return t&&this.routputs([t]),this},rinputs:function(t){return t&&(this.inputs=this.inputs.concat(t)),this},rinput:function(t){return t&&this.inputs.push(t),this},destroy:function(){try{this.emit("destroy"),this.offAll();for(var t in this)this.hasOwnProperty(t)&&(this[t]=null,delete this[t])}catch(e){}},_clear:function(){this.params={},this.inputs=[],this.outputs=[],this.rstream=!1,this.delayed=!1,this.api=null,this.file=null,this.entities=null,this.ioFilter=null},_prepRequest:function(t,e){var r=this.req,o=this.file;if(this.api.upload?i||this.req.type("multipart/form-data"):r.type("form"),r.on("error",function(t){t=t||{code:"UNKNOWN CODE",text:"UNKNOWN ERROR"},this._handleError({status:t.code||"UNKNOWN CODE",text:t})}.bind(this)),this.share(e?e.__cookies__:null),e&&this.data(e),this.inputs.length>0&&this.data({inputs:y.encode(this.inputs)}),this.outputs.length>0&&this.data({robjects:this.outputs.join()}),this.cookies&&this.cookies.forEach(function(t){r.set("Cookie",t)}),this.api.upload){for(var n in this.params)r.field(n,this.params[n]||this.params[n]===!1?this.params[n]+"":"");r.attach("file",this.rstream?a.createReadStream(o):o)}else r["GET"===this.api.method?"query":"send"](this.params)},_handleError:function(t){var e=t.status,r=t.body&&t.body.deployr?t.body:t,i=200!==e||r.deployr&&!r.deployr.response.success;return i&&(r={get:function(t){return l.get(this.deployr.response,t)},deployr:{response:{success:!1,call:this.api.call,errorCode:r.deployr?r.deployr.response.errorCode:e,error:r.deployr?r.deployr.response.error:r.text}}},h.error("error()",this.api,r,t),this.logger.error("error()",this.api,r,t),this.globalEvts&&o(this.api.call,r),this.emit("error",r),this.emit("deployr-io:"+r.deployr.response.errorCode,r),this.deferred.reject(r)),i}});i&&(window.Revolution=window.Revolution||t("./lib/deprecated")),e.exports={DeployR:E,apis:function(t){return t?Object.keys(c):c},configure:function(t){t=t||{};for(var e in t)j.set(e,t[e]);return j.sticky||j.set("cookies",null),h.setLevel(j.logging?h.DEBUG:h.OFF),this},io:function(t){return E["new"](t)},auth:function(t,e){var r={username:t,password:e};return E["new"]("/r/user/login").data(r).end()},script:function(){var t=l.signature(arguments),e=t.opts,r=t.api;return t.create?E["new"]("/r/project/create").end(function(t){return{project:t.get("project").project}}).io(r).data(e):E["new"](r).data(e)},pipeline:function(t){function e(){i.add(function(){t.shift().drain().then(function(t){n.push(t),a.push(c),i.isEmpty()&&(r.configure(u),o.resolve({results:n,errors:a})),i.take()},function(t){n.push(c),a.push(t),i.isEmpty()&&0===n.length&&(r.configure(u),o.reject(a)),i.take()})},null,!0)}var r=this,o=s(),i=new f,n=[],a=[],c=null,u={sticky:j.sticky,cookies:j.cookies};t=t.slice(0),r.configure({sticky:!0});for(var l=0;l<t.length;l++)e();return i.take(),o.promise},es:function(t){var e=u["new"](j.host,t);if(t&&t.username&&t.password){var r=this.auth(t.username,t.password);r.ensure(function(){e.share(r.getCookies()),e.flush()})}return e},RInput:{numeric:function(t,e){return v["new"](t,e).numeric()},integer:function(t,e){return v["new"](t,e).integer()},logical:function(t,e){return v["new"](t,e).logical()},character:function(t,e){return v["new"](t,e).character()},date:function(t,e){return v["new"](t,e).date()},posixct:function(t,e){return v["new"](t,e).posixct()},numericVector:function(t,e){return v["new"](t,e).numericVector()},integerVector:function(t,e){return v["new"](t,e).integerVector()},logicalVector:function(t,e){return v["new"](t,e).logicalVector()},characterVector:function(t,e){return v["new"](t,e).characterVector()},dateVector:function(t,e){return v["new"](t,e).dateVector()},posixctVector:function(t,e){return v["new"](t,e).posixctVector()},list:function(t,e){return v["new"](t,e).list()},dataframe:function(t,e){return v["new"](t,e).dataframe()},factor:function(t,e,r,o){var i={levels:r,labels:o};return v["new"](t,e,i).factor()},ordered:function(t,e,r,o){var i={levels:r,labels:o};return v["new"](t,e,i).ordered()},numericMatrix:function(t,e){return v["new"](t,e).numericMatrix()},integerMatrix:function(t,e){return v["new"](t,e).integerMatrix()},logicalMatrix:function(t,e){return v["new"](t,e).logicalMatrix()},characterMatrix:function(t,e){return v["new"](t,e).characterMatrix()}}}}).call(this,t("_process"))},{"./apis.json":2,"./lib/deprecated":3,"./lib/emitter":4,"./lib/encoder":5,"./lib/es":6,"./lib/lang":7,"./lib/logger":8,"./lib/queue":10,"./lib/rinput":11,"./lib/rinputs":12,"./lib/selfish":14,"./lib/utils":15,_process:17,"d.js":18,fs:16,superagent:19}],2:[function(t,e,r){e.exports={"/r/user/login":{method:"POST",format:"json"},"/r/user/logout":{method:"POST",format:"json"},"/r/user/about":{method:"POST",format:"json"},"/r/user/autosave":{method:"POST",format:"json"},"/r/user/release":{method:"POST",format:"json"},"/r/project/create":{method:"POST",format:"json"},"/r/project/pool":{method:"POST",format:"json"},"/r/project/recycle":{method:"POST",format:"json"},"/r/project/list":{method:"POST",format:"json"},"/r/project/ping":{method:"POST",format:"json"},"/r/project/about":{method:"POST",format:"json"},"/r/project/about/update":{method:"POST",format:"json"},"/r/project/save":{method:"POST",format:"json"},"/r/project/saveas":{method:"POST",format:"json"},"/r/project/close":{method:"POST",format:"json"},"/r/project/grant":{method:"POST",format:"json"},"/r/project/import":{method:"POST",format:"json",upload:!0},"/r/project/export":{method:"POST",format:"json"},"/r/project/delete":{method:"POST",format:"json"},"/r/project/execute/code":{method:"POST",format:"json"},"/r/project/execute/script":{method:"POST",format:"json"},"/r/project/execute/interrupt":{method:"POST",format:"json"},"/r/project/execute/console":{method:"POST",format:"json"},"/r/project/execute/history":{method:"POST",format:"json"},"/r/project/execute/flush":{method:"POST",format:"json"},"/r/project/execute/result/list":{method:"POST",format:"json"},"/r/project/execute/result/download":{method:"POST",format:"json"},"/r/project/execute/result/delete":{method:"POST",format:"json"},"/r/project/workspace/list":{method:"POST",format:"json"},"/r/project/workspace/get":{method:"POST",format:"json"},"/r/project/workspace/upload":{method:"POST",format:"json",upload:!0},"/r/project/workspace/transfer":{method:"POST",format:"json"},"/r/project/workspace/push":{method:"POST",format:"json"},"/r/project/workspace/save":{method:"POST",format:"json"},"/r/project/workspace/store":{method:"POST",format:"json"},"/r/project/workspace/load":{method:"POST",format:"json"},"/r/project/workspace/delete":{method:"POST",format:"json"},"/r/project/directory/list":{method:"POST",format:"json"},"/r/project/directory/upload":{method:"POST",format:"json",upload:!0},"/r/project/directory/transfer":{method:"POST",format:"json"},"/r/project/directory/write":{method:"POST",format:"json"},"/r/project/directory/update":{method:"POST",format:"json"},"/r/project/directory/store":{method:"POST",format:"json"},"/r/project/directory/load":{method:"POST",format:"json"},"/r/project/directory/download":{method:"POST",format:"json"},"/r/project/directory/delete":{method:"POST",format:"json"},"/r/project/package/list":{method:"POST",format:"json"},"/r/project/package/attach":{method:"POST",format:"json"},"/r/project/package/detach":{method:"POST",format:"json"},"/r/job/list":{method:"POST",format:"json"},"/r/job/submit":{method:"POST",format:"json"},"/r/job/schedule":{method:"POST",format:"json"},"/r/job/query":{method:"POST",format:"json"},"/r/job/cancel":{method:"POST",format:"json"},"/r/job/delete":{method:"POST",format:"json"},"/r/repository/directory/list":{method:"POST",format:"json"},"/r/repository/directory/create":{method:"POST",format:"json"},"/r/repository/directory/rename":{method:"POST",format:"json"},"/r/repository/directory/copy":{method:"POST",format:"json"},"/r/repository/directory/move":{method:"POST",format:"json"},"/r/repository/directory/update":{method:"POST",format:"json"},"/r/repository/script/list":{method:"POST",format:"json"},"/r/repository/script/execute":{method:"POST",format:"json"},"/r/repository/script/render":{method:"POST",format:"json"},"/r/repository/script/interrupt":{method:"POST",format:"json"},"/r/repository/shell/execute":{method:"POST",format:"json"},"/r/repository/directory/archive":{method:"POST",format:"json"},"/r/repository/directory/upload":{method:"POST",format:"json",upload:!0},"/r/repository/directory/download":{method:"POST",format:"json"},"/r/repository/directory/delete":{method:"POST",format:"json"},"/r/repository/file/list":{method:"POST",format:"json"},"/r/repository/file/fetch":{method:"POST",format:"json"},"/r/repository/file/fetch":{method:"POST",format:"json"},"/r/repository/file/upload":{method:"POST",format:"json",upload:!0},"/r/repository/file/transfer":{method:"POST",format:"json"},"/r/repository/file/write":{method:"POST",format:"json"},"/r/repository/file/update":{method:"POST",format:"json"},"/r/repository/file/diff":{method:"POST",format:"json"},"/r/repository/file/revert":{method:"POST",format:"json"},"/r/repository/file/grant":{method:"POST",format:"json"},"/r/repository/file/download":{method:"POST",format:"json"},"/r/repository/file/delete":{method:"POST",format:"json"},"/r/repository/file/copy":{method:"POST",format:"json"},"/r/repository/file/move":{method:"POST",format:"json"},"/r/server/info":{method:"GET",format:"json"}}},{}],3:[function(t,e,r){function o(t,e){var r=e||globalConfig.entity;if(r)for(var o=t.deployr.response,i=h,n=0;n<i.length;n++){var s=i[n];if(o[s]&&r[s]&&r[s].parser){var a=r[s].scope||this;o[s]=r[s].parser.call(a,o[s])}}return t}function i(t){return t=t.replace("/r/",""),t.toLowerCase().replace(/\/(.)/g,function(t,e){return e.toUpperCase()})}function n(t){for(var e=[],r=0;r<t.length;r++)e.push(t[r].normalize());return e}function s(t){}function a(t){}var c,u,l=(t("./lang"),t("./selfish").Base),p=t("./rinput"),h=["user","project","workspace","execution","directory","repository","packages"],f={ENDPOINT_WHITELIST:{login:"/r/user/login",logout:"/r/user/logout",projectCreate:"/r/project/create",projectClose:"/r/project/close",projectAboutUpdate:"/r/project/about/update",projectSave:"/r/project/save",projectSaveAs:"/r/project/saveas",clientProjectSave:"/r/client/project/save",clientProjectClose:"/r/client/project/close"},session:{},config:{},setUnloadConfig:function(t){t=t||{},this.config={disableautosave:t.disableautosave||!0,dropworkspace:t.dropworkspace||!0,dropdirectory:t.dropdirectory||!0,drophistory:t.drophistory||!0,flushhistory:t.flushhistory||!0}},setSession:function(t){this.session=t},setProject:function(t){this.session.project=t},clearSession:function(){this.session={}},clearProject:function(){this.session.project=null},unloadHandler:function(){try{var t=this.session.project;if(t){var e=this._config;e.project=t.id,e.projectcookie=t.cookie,deployr.io("/r/project/close").data(e).sync().end()}}catch(r){throw new Error(r)}}},d=l.extend({initialize:function(t,e,r){this.type=t,this.rclass=e,this.rinput=r},getType:function(){return this.type},getRClass:function(){return this.rclass},getName:function(){return this.rinput.name},getValue:function(){return this.rinput.value},getLevels:function(){return this.rinput.levels},getLabels:function(){return this.rinput.labels},getOrdered:function(){return this.rinput.ordered},normalize:function(){return this.rinput}});s.prototype={events:{},scope:null,on:function(t,e){return t in this.events==!1&&(this.events[t]=[]),this.events[t].push(e),a('Emitter.on("'+t+'")'),this},emit:function(t){if(t in this.events==!1)return this;for(var e=0;e<this.events[t].length;e++)a('Fired event: "'+t+'"'),this.events[t][e].apply(this.scope||this,Array.prototype.slice.call(arguments,1));return this},removeAllListeners:function(t){if(t){if(t in this.events==!1)return this;delete this.events[t]}else for(var e in this.events)delete this.events[e];return this},removeListenerAt:function(t,e){var r=this.events[t],o=r.slice(e+1);r.length=e,r.push.apply(r,o),this.events[t]=r},off:function(t,e){if(t in this.events==!1)return this;if(!e)return this.removeAllListeners(t);for(var r=0;r<this.events[t].length;r++)if(this.events[t][r]==e)return this.removeListenerAt(t,r),this;return this}},u=new s,c={version:t("../package").version,Event:{on:function(t,e,r){u.on(t,e,r)},detach:function(t,e,r){u.off(t,e)}},RDataFactory:{createNumeric:function(t,e){return d["new"]("primitive","numeric",p["new"](t,e).numeric())},createInteger:function(t,e){return d["new"]("primitive","integer",p["new"](t,e).integer())},createBoolean:function(t,e){return d["new"]("primitive","numeric",p["new"](t,e).logical())},createString:function(t,e){return d["new"]("primitive","character",p["new"](t,e).character())},createDate:function(t,e){return d["new"]("date","Date",p["new"](t,e).date())},createPOSIXDate:function(t,e){return d["new"]("date","POSIXct",p["new"](t,e).posixct())},createNumericVector:function(t,e){return d["new"]("vector","numeric",p["new"](t,e).numericVector())},createIntegerVector:function(t,e){return d["new"]("vector","integer",p["new"](t,e).integerVector())},createBooleanVector:function(t,e){return d["new"]("vector","logical",p["new"](t,e).logicalVector())},createStringVector:function(t,e){return d["new"]("vector","character",p["new"](t,e).characterVector())},createDateVector:function(t,e){return d["new"]("type","Date",p["new"](t,e).dateVector())},createPOSIXDateVector:function(t,e){return d["new"]("vector","POSIXct",p["new"](t,e).posixctVector())},createList:function(t,e){return d["new"]("list","list",p["new"](t,e).list())},createDataframe:function(t,e){return d["new"]("dataframe","data.frame",p["new"](t,e).dataframe())},createFactor:function(t,e,r,o,i){var n={levels:o,labels:i};return r?d["new"]("factor","factor",p["new"](t,e,n).ordered()):d["new"]("factor","factor",p["new"](t,e,n).factor())},createNumericMatrix:function(t,e){return d["new"]("matrix","matrix",p["new"](t,e).numericMatrix())},createIntegerMatrix:function(t,e){return d["new"]("matrix","matrix",p["new"](t,e).integerMatrix())},createBooleanMatrix:function(t,e){return d["new"]("matrix","matrix",p["new"](t,e).logicalMatrix())},createStringMatrix:function(t,e){return d["new"]("matrix","matrix",p["new"](t,e).characterMatrix())}},DeployR:{init:function(t){if(t=t||{},t.compatibility,t.events){var e=t.events;if(e.unload&&(f.setUnloadConfig(e.unload),c.Event.on("deployR:unload",f.unloadHandler,f)),e.globalIO){var r=e.globalIO.scope||window,o=e.globalIO.lifecycle,i=e.globalIO.statusCode;if(o)for(var n in o)c.Event.on("deployR-io:"+n,o[n],r);if(i)for(var n in i)c.Event.on("deployR-io:"+n,i[n],r)}}deployr.configure({host:t.deployrURI,cors:t.deployrURI?!0:!1,logging:t.logging,sticky:!0})},io:function(t,e,r){console&&console.warn('"'+i(t)+'()" API is now deprecated.'),r=r||{},e=e||{};var s=e.transaction||{},a=s.arguments,c=s.statusCode||{},l=r.scope||window,p=e.robjects,h=e.inputs;e.transaction&&delete e.transaction,e.method&&delete e.method,e.on&&delete e.on,e.format&&delete e.format,e.inputs&&delete e.inputs,e.robjects&&delete e.robjects;var f=deployr.io(t).data(e||{}).error(function(e){u.emit("deployR-io:failure",[e,t,a]),r.failure&&r.failure.apply(l,[e,t,a]),u.emit("deployR-io:"+code,[e,t,a])});if(h&&f.rinputs(n(h)),p&&f.routputs(p),s.sync&&f.sync(),s.timeout&&f.timeout(s.timeout),c)for(var d in c)f.on("deployr-io:"+d,function(e){var r=c,o=e.deployr.response.error,i=e.deployr.response.errorCode;r[i].apply(l,[e,i,o,t,a])});return u.emit("deployR-io:start"),r.start&&r.start.apply(l,[t,a]),f.end(function(e){u.emit("deployR-io:complete"),r.complete&&r.complete.apply(l,[e,t,a]),s.entity&&(e=o(e,s.entity)),u.emit("deployR-io:success",[e,t]),r.success&&r.success.apply(l,[e,t,a]),u.emit("deployR-io:end",[e,t]),r.end&&r.end.apply(l,[e,t,a])}),f},parseInputs:function(t){return t},projectWorkspaceList:function(t,e){return this.io("/r/project/workspace/list",t,e)},projectWorkspaceGet:function(t,e){return this.io("/r/project/workspace/get",t,e)},projectWorkspaceUpload:function(t,e){t.format="text";({data:t,method:"POST",form:{id:t.formId},on:e});return this.io("/r/project/workspace/upload",t,e)},projectWorkspaceTransfer:function(t,e){return this.io("/r/project/workspace/transfer",t,e)},projectWorkspacePush:function(t,e){return this.io("/r/project/workspace/push",t,e)},projectWorkspaceSave:function(t,e){return this.io("/r/project/workspace/save",t,e)},projectWorkspaceStore:function(t,e){return this.io("/r/project/workspace/store",t,e)},projectWorkspaceLoad:function(t,e){return this.io("/r/project/workspace/load",t,e)},projectWorkspaceDelete:function(t,e){return this.io("/r/project/workspace/delete",t,e)},projectCreate:function(t,e){return this.io("/r/project/create",t,e)},projectPool:function(t,e){return this.io("/r/project/pool",t,e)},projectRecycle:function(t,e){return this.io("/r/project/recycle",t,e)},projectList:function(t,e){return this.io("/r/project/list",t,e)},projectPing:function(t,e){return this.io("/r/project/ping",t,e)},projectAbout:function(t,e){return this.io("/r/project/about",t,e)},projectAboutUpdate:function(t,e){return this.io("/r/project/about/update",t,e)},projectSave:function(t,e){return this.io("/r/project/save",t,e)},projectSaveas:function(t,e){return this.io("/r/project/saveas",t,e)},projectClose:function(t,e){return this.io("/r/project/close",t,e)},projectGrant:function(t,e){return this.io("/r/project/grant",t,e)},projectImport:function(t,e){t.format="text";({data:t,method:"POST",form:{id:t.formId},on:e});return this.io("/r/project/import",t,e)},projectExport:function(t,e){return this.io("/r/project/export",t,e)},projectDelete:function(t,e){return this.io("/r/project/delete",t,e)},projectExecuteCode:function(t,e){return this.io("/r/project/execute/code",t,e)},projectExecuteScript:function(t,e){return this.io("/r/project/execute/script",t,e)},projectExecuteInterrupt:function(t,e){return this.io("/r/project/execute/interrupt",t,e)},projectExecuteConsole:function(t,e){return this.io("/r/project/execute/console",t,e)},projectExecuteHistory:function(t,e){return this.io("/r/project/execute/history",t,e)},projectExecuteFlush:function(t,e){return this.io("/r/project/execute/flush",t,e)},projectExecuteResultList:function(t,e){return this.io("/r/project/execute/result/list",t,e)},projectExecuteResultDownload:function(t,e){return this.io("/r/project/execute/result/download",t,e)},projectExecuteResultDelete:function(t,e){return this.io("/r/project/execute/result/delete",t,e)},projectDirectoryList:function(t,e){return this.io("/r/project/directory/list",t,e)},projectDirectoryUpload:function(t,e){t.format="text";({data:t,method:"POST",form:{id:t.formId},on:e});return this.io("/r/project/directory/upload",t,e)},projectDirectoryTransfer:function(t,e){return this.io("/r/project/directory/transfer",t,e)},projectDirectoryWrite:function(t,e){return this.io("/r/project/directory/write",t,e)},projectDirectoryUpdate:function(t,e){return this.io("/r/project/directory/update",t,e)},projectDirectoryStore:function(t,e){return this.io("/r/project/directory/store",t,e)},projectDirectoryLoad:function(t,e){return this.io("/r/project/directory/load",t,e)},projectDirectoryDownload:function(t,e){return this.io("/r/project/directory/download",t,e)},projectDirectoryDelete:function(t,e){return this.io("/r/project/directory/delete",t,e)},projectPackageList:function(t,e){return this.io("/r/project/package/list",t,e)},projectPackageAttach:function(t,e){return this.io("/r/project/package/attach",t,e)},projectPackageDetach:function(t,e){return this.io("/r/project/package/detach",t,e)},userLogin:function(t,e){return this.io("/r/user/login",t,e)},userLogout:function(t,e){return this.io("/r/user/logout",t,e)},userAbout:function(t){return this.io("/r/user/about",{},t)},userAutosave:function(t,e){return this.io("/r/user/autosave",t,e)},repositoryScriptList:function(t){return this.io("/r/repository/script/list",{},t)},repositoryScriptExecute:function(t,e){return this.io("/r/repository/script/execute",t,e)},repositoryScriptRender:function(t,e){return this.io("/r/repository/script/render",t,e)},repositoryScriptInterrupt:function(t){return this.io("/r/repository/script/interrupt",config,t)},repositoryFileList:function(t,e){return this.io("/r/repository/file/list",t,e)},repositoryFileUpload:function(t,e){t.format="text";({data:t,method:"POST",form:{id:t.formId},on:e});return this.io("/r/repository/file/upload",t,e)},repositoryFileTransfer:function(t,e){return this.io("/r/repository/file/transfer",t,e)},repositoryFileWrite:function(t,e){return this.io("/r/repository/file/write",t,e)},repositoryFileUpdate:function(t,e){return this.io("/r/repository/file/update",t,e)},repositoryFileRevert:function(t,e){return this.io("/r/repository/file/revert",t,e)},repositoryFileDiff:function(t,e){return this.io("/r/repository/file/diff",t,e)},repositoryFileGrant:function(t,e){return this.io("/r/repository/file/grant",t,e)},repositoryFileDownload:function(t,e){return this.io("/r/repository/file/download",t,e)},repositoryFileDelete:function(t,e){return this.io("/r/repository/file/delete",t,e)},repositoryFileFetch:function(t,e){return this.io("/r/repository/file/fetch",t,e)},repositoryFileCopy:function(t,e){return this.io("/r/repository/file/copy",t,e)},repositoryFileMove:function(t,e){return this.io("/r/repository/file/move",t,e)},repositoryDirectoryList:function(t,e){return this.io("/r/repository/directory/list",t,e)},repositoryDirectoryCreate:function(t,e){return this.io("/r/repository/directory/create",t,e)},repositoryDirectoryRename:function(t,e){return this.io("/r/repository/directory/rename",t,e)},repositoryDirectoryCopy:function(t,e){return this.io("/r/repository/directory/copy",t,e)},repositoryDirectoryMove:function(t,e){return this.io("/r/repository/directory/move",t,e)},repositoryDirectoryUpdate:function(t,e){return this.io("/r/repository/directory/update",t,e)},repositoryDirectoryArchive:function(t,e){return this.io("/r/repository/directory/archive",t,e)},repositoryDirectoryUpload:function(t,e){t=t||{},t.format="text";({data:t,method:"POST",form:{id:t.formId},on:e});return this.io("/r/repository/directory/upload",t,e)},repositoryDirectoryDownload:function(t,e){return this.io("/r/repository/directory/download",t,e)},repositoryDirectoryDelete:function(t,e){return this.io("/r/repository/directory/delete",t,e)},jobList:function(t,e){return this.io("/r/job/list",t,e)},jobSubmit:function(t,e){return this.io("/r/job/submit",t,e)},jobSchedule:function(t,e){return this.io("/r/job/schedule",t,e)},jobQuery:function(t,e){return this.io("/r/job/query",t,e)},jobCancel:function(t,e){return this.io("/r/job/list",t,e)},jobDelete:function(t,e){return this.io("/r/job/delete",t,e)}}},e.exports=c},{"../package":22,"./lang":7,"./rinput":11,"./selfish":14}],4:[function(t,e,r){function o(t){}var i=t("./selfish").Base;e.exports=i.extend({initialize:function(){this.events={},this.scope=null},on:function(t,e){return t in this.events==!1&&(this.events[t]=[]),this.events[t].push(e),o('Emitter.on("'+t+'")'),this},emit:function(t){if(t in this.events==!1)return this;for(var e=0;e<this.events[t].length;e++)o('Fired event: "'+t+'"'),this.events[t][e].apply(this.scope||this,Array.prototype.slice.call(arguments,1));return this},offAll:function(t){if(t){if(t in this.events==!1)return this;delete this.events[t]}else for(var e in this.events)delete this.events[e];return this},offAt:function(t,e){var r=this.events[t],o=r.slice(e+1);r.length=e,r.push.apply(r,o),this.events[t]=r},off:function(t,e){if(t in this.events==!1)return this;if(!e)return this.offAll(t);for(var r=0;r<this.events[t].length;r++)if(this.events[t][r]==e)return this.offAt(t,r),this;return this}})},{"./selfish":14}],5:[function(t,e,r){function o(t,e){for(var r=[],o=0;o<t.length;o++)r.push(i(t[o],e));return r}function i(t,e){function r(t,e,r){for(var o=""+Math.abs(t),i=t>=0;o.length<e;)o="0"+o;return(i?r?"+":"":"-")+o}var o=t.getFullYear(),i=t.getMonth()+1,n=t.getDate(),s=t.getHours(),a=t.getMinutes(),c=t.getSeconds(),u=t.getTimezoneOffset(),l="";if(i=10>i?"0"+i:i,s=10>s?"0"+s:s,a=10>a?"0"+a:a,c=10>c?"0"+c:c,l=o+"-"+i+"-"+n,e===p.RPOSIX_DATE||e===p.RPOSIX_DATE_VECTOR){var h=s+":"+a+":"+c,f=-u,d="+";0>f&&(f=-f,d="-"),u=d+r(f/60,2)+""+r(f%60,2),l+=" "+h+" "+u}return l}function n(t,e){for(var r=t.value,s=0;s<r.length;s++){var a=r[s];a.type===p.RDATAFRAME?e=n(a,e):(u.isDate(a.type)&&(a.value=c.isArray(a.value)?o(a.value,a.type):i(a.value,a.type)),a.type=u.deployrToR(a.type),e.value.push(a))}return e}function s(t){for(var e={type:l.DATAFRAME,value:[],name:t.name},r=t.value,s=0;s<r.length;s++){var a=r[s];a.type===p.RDATAFRAME?e=n(a,e):(u.isDate(a.type)&&(a.value=c.isArray(a.value)?o(a.value,a.type):i(a.value,a.type)),a.type=u.deployrToR(a.type),e.value.push(a))}return e}function a(t){for(var e,r={type:l.LIST,value:[],name:t.name},n=t.value,c=0;c<n.length;c++){var u=n[c];switch(u.type){case p.RDATAFRAME:e=s(u);break;case p.RLIST:e=a(u);break;case p.RNUMERIC_MATRIX:case p.RINTEGER_MATRIX:case p.RBOOLEAN_MATRIX:case p.RSTRING_MATRIX:e={name:u.name,type:l.MATRIX,value:u.value};break;case p.RDATE:case p.RPOSIX_DATE:e={name:u.name,type:l.DATE,format:u.format,
value:i(u.value,u.type)};break;case p.RFACTOR:case p.RORDERED:e={name:u.name,type:l.FACTOR,ordered:u.ordered,labels:u.labels,levels:u.levels,value:u.value};break;case p.RSTRING:case p.RBOOLEAN:case p.RNUMERIC:case p.RINTEGER:e={name:u.name,type:l.PRIMITIVE,value:u.value};break;case p.RNUMERIC_VECTOR:case p.RINTEGER_VECTOR:case p.RBOOLEAN_VECTOR:case p.RSTRING_VECTOR:e={name:u.name,type:l.VECTOR,value:u.value};break;case p.RDATE_VECTOR:case p.RPOSIX_DATE_VECTOR:e={name:u.name,type:l.VECTOR,value:o(u.value,u.type),format:u.format};break;default:throw new Error('No RDataType found for "'+u.type+'"')}r.value.push(e)}return r}var c=t("./lang"),u=t("./rtypes"),l=u.r,p=u.deployr;e.exports={encode:function(t){for(var e={},r=0;r<t.length;r++){var n=t[r];switch(n.type){case p.RDATAFRAME:e[n.name]=s(n);break;case p.RLIST:e[n.name]=a(n);break;case p.RNUMERIC_MATRIX:case p.RINTEGER_MATRIX:case p.RBOOLEAN_MATRIX:case p.RSTRING_MATRIX:e[n.name]={type:l.MATRIX,value:n.value};break;case p.RDATE:case p.RPOSIX_DATE:e[n.name]={type:l.DATE,format:n.format,value:i(n.value,n.type)};break;case p.RFACTOR:case p.RORDERED:e[n.name]={type:l.FACTOR,ordered:n.ordered,labels:n.labels,levels:n.levels,value:n.value};break;case p.RSTRING:case p.RBOOLEAN:case p.RNUMERIC:case p.RINTEGER:e[n.name]={type:l.PRIMITIVE,value:n.value};break;case p.RNUMERIC_VECTOR:case p.RINTEGER_VECTOR:case p.RBOOLEAN_VECTOR:case p.RSTRING_VECTOR:e[n.name]={type:l.VECTOR,value:n.value};break;case p.RDATE_VECTOR:case p.RPOSIX_DATE_VECTOR:e[n.name]={type:l.VECTOR,value:o(n.value,n.type),format:n.format};break;default:throw new Error('No RDataType found for "'+n.type+'"')}}return JSON.stringify(e)}}},{"./lang":7,"./rtypes":13}],6:[function(t,e,r){var o=t("./optional"),i=o("ws"),n=t("./queue"),s=t("./emitter"),a=t("./selfish").Base,c=t("./utils").merge,u=a.extend(s,{initialize:function(t,e){s.initialize.call(this,{}),this.host=t,this.options=e||{},this.options.log=this.options.log||this.LOG.error,this.ws=null,this.q=new n,this.channel={}},LOG:{info:"info",debug:"debug",error:"error"},open:function(t){var e=this,r=(this.host||"")+"/deployr/r/event/stream?",o=[];return t=t||{},t.headers=t.headers||{},t=this.options=c(t,this.channel),this.cookies=this.cookies?this.cookies:t.headers.Cookie,t.project?o.push("project="+t.project):t.job&&o.push("job="+t.job),t.management?o.push("managementEventOnly=true"):t.httponly?o.push("httpEventOnly=true"):t.revoonly&&o.push("revoEventOnly=true"),r+=o.join("&").substr(0),r=r.replace(/^http/,"ws"),this.q["yield"](!0),this.q.add(function(){var t=this.cookies?{Cookie:this.cookies}:{};this.emit("es:connecting",{uri:r,headers:t});var o=new i(r,"http",{headers:t});o.onopen=function(t){e.emit("es:open",t)};var n="";o.onmessage=function(t){try{if(t.data.split("!|!")[1]){n+=t.data.split("!|!")[1],t=JSON.parse(n),n="";var r=t.deployr.response.event.type;e.emit("es:"+r.replace("Event",""),t)}}catch(o){}},o.onerror=function(t){e.emit("es:error",t)},o.onclose=function(t){e.emit("es:disconnect",t)},this.ws=o},this),t.force&&this.flush(),this},close:function(){return this.ws&&this.ws.close(),this},error:function(t){return this.on("es:error",t),this},all:function(){return this.channel={revoonly:!0},this},session:function(){return this.channel={httponly:!0},this},project:function(t){return this.channel={project:t},this},job:function(t){return this.channel={job:t},this},management:function(){return this.channel={management:!0},this},flush:function(){this.q["yield"](!1),this.q.flush()},share:function(t){this.cookies=t}});e.exports=u},{"./emitter":4,"./optional":9,"./queue":10,"./selfish":14,"./utils":15}],7:[function(t,e,r){var o={},i=Object.prototype.toString,n={undefined:"undefined",number:"number","boolean":"boolean",string:"string","[object Function]":"function","[object RegExp]":"regexp","[object Array]":"array","[object Date]":"date","[object Error]":"error"},s=!1;o.isNull=function(t){return null===t},o.isUndefined=function(t){return"undefined"==typeof t},o.isObject=function(t,e){var r=typeof t;return t&&("object"===r||!e&&("function"===r||o.isFunction(t)))||!1},o.isArray=!s&&Array.isArray||function(t){return"array"===o.type(t)},o.isFunction=function(t){return"function"==typeof t},o.isBoolean=function(t){return"boolean"==typeof t},o.isDate=function(t){return"date"===o.type(t)&&"Invalid Date"!==t.toString()&&!isNaN(t)},o.isNumber=function(t){return"number"==typeof t&&isFinite(t)},o.isString=function(t){return"string"==typeof t},o.type=function(t){return n[typeof t]||n[i.call(t)]||(t?"object":"null")},e.exports=o},{}],8:[function(t,e,r){function o(t,e){function r(t){var e="==================================================================================================================\n",r=0;return r=t===s.DEBUG||t===s.ERROR?8:t===s.INFO||t===s.WARN?8:7,{start:e.substring(r),end:e}}if(console){var o,i=Array.prototype.slice.call(t,0),n=e.name,a=e.level===s.ERROR,c=r(e.level);o=e.level===s.WARN&&console.warn?"warn":e.level===s.ERROR&&console.error?"error":e.level===s.INFO&&console.info?"info":"log",i.unshift("["+(a?s.ERROR.name:n)+"] "+c.start),i.push(c.end),console[o](i[0],[i[1]+" ---> "+i[2].call]);for(var u=2;u<i.length;u++)console.log(i[u])}}function i(t,e,r){this.id=t,this.context=e||s.DEBUG}var n,s={},a={};i.prototype={log:function(t,e){t.value>=this.context.value&&o(e,{level:t,name:this.context.name,value:this.context.value})},debug:function(){this.log(s.DEBUG,arguments)},error:function(){this.log(s.ERROR,arguments)},info:function(){this.log(s.INFO,arguments)},warn:function(){this.log(s.WARN,arguments)},setLevel:function(t){t&&"value"in t&&(this.context=t)}},s.DEBUG={value:1,name:"DEBUG"},s.INFO={value:2,name:"INFO"},s.WARN={value:4,name:"WARN"},s.ERROR={value:8,name:"ERROR"},s.OFF={value:99,name:"OFF"},s.setLevel=function(t){n.setLevel(t)},s.debug=function(){n.debug.apply(n,arguments)},s.info=function(){n.info.apply(n,arguments)},s.warn=function(){n.warn.apply(n,arguments)},s.error=function(){n.error.apply(n,arguments)},s.get=function(t,e,r){return a[t]||function(){return a[t]=new i(t,e,r),a[t]}()},n=s.get("global"),e.exports=s},{}],9:[function(t,e,r){e.exports=function(e){try{return t(e)}catch(r){}}},{}],10:[function(t,e,r){function o(){this.emptyCallback=null,this.callbacks=[],this.yielded=!1,this.response=null,this.responseChain=[]}o.prototype={add:function(t,e,r){this.yielded||r?this.callbacks.push({fn:t,ctx:e}):t.apply(e||this,[this.response])},size:function(){return this.callbacks.length},isEmpty:function(){return 0===this.callbacks.length},empty:function(t,e){this.emptyCallback={fn:t,ctx:e}},"yield":function(t){this.yielded=t},take:function(t,e,r){var o;t&&(this.response=t,this.responseChain.push(t)),!this.yielded&&this.callbacks[0]&&(o=this.callbacks.shift(),o.fn.apply(o.ctx||this,[this.responseChain,e,r]),this.callbacks[0]&&this.emptyCallback&&this.emptyCallback.fn.call(this.emptyCallback.ctx||this))},flush:function(t,e,r){for(t&&(this.response=t,this.responseChain.push(t));this.callbacks[0]&&!this.yielded;){var o=this.callbacks.shift();o.fn.apply(o.ctx||this,[this.responseChain,e,r]),this.callbacks[0]&&this.emptyCallback&&this.emptyCallback.fn.call(this.emptyCallback.ctx||this)}}},e.exports=o},{}],11:[function(t,e,r){var o=t("./selfish").Base,i=t("./rtypes");e.exports=o.extend(i,{initialize:function(t,e,r){this.name=t,this.value=e,this.options=r||{}},numeric:function(){return this.value=parseFloat(this.value),this.assert({type:this.deployr.RNUMERIC,name:this.name,value:this.value,toString:this.toString})},integer:function(){return this.value=parseInt(this.value,10),this.assert({type:this.deployr.RINTEGER,name:this.name,value:this.value,toString:this.toString})},logical:function(){return this.assert({type:this.deployr.RBOOLEAN,name:this.name,value:this.value,toString:this.toString})},character:function(){return this.assert({type:this.deployr.RSTRING,name:this.name,value:this.value,toString:this.toString})},date:function(){return this.assert({type:this.deployr.RDATE,name:this.name,value:this.value,format:"yyyy-MM-dd",toString:this.toString})},posixct:function(){return this.assert({type:this.deployr.RPOSIX_DATE,name:this.name,value:this.value,format:"yyyy-MM-dd HH:mm:ss Z",toString:this.toString})},numericVector:function(){return this.assert({type:this.deployr.RNUMERIC_VECTOR,name:this.name,value:this.value,toString:this.toString})},integerVector:function(){return this.assert({type:this.deployr.RINTEGER_VECTOR,name:this.name,value:this.value,toString:this.toString})},logicalVector:function(){return this.assert({type:this.deployr.RBOOLEAN_VECTOR,name:this.name,value:this.value,toString:this.toString})},characterVector:function(){return this.assert({type:this.deployr.RSTRING_VECTOR,name:this.name,value:this.value,toString:this.toString})},dateVector:function(){return this.assert({type:this.deployr.RDATE_VECTOR,name:this.name,value:this.value,format:"yyyy-MM-dd",toString:this.toString})},posixctVector:function(){return this.assert({type:this.deployr.RPOSIX_DATE_VECTOR,name:this.name,value:this.value,format:"yyyy-MM-dd HH:mm:ss Z",toString:this.toString})},list:function(){return this.assert({type:this.deployr.RLIST,name:this.name,value:this.value,toString:this.toString})},dataframe:function(){return this.assert({type:this.deployr.RDATAFRAME,name:this.name,value:this.value,toString:this.toString})},factor:function(){var t=this.options;return this.assert({type:this.deployr.RFACTOR,name:this.name,value:this.value,ordered:!1,levels:t.levels,labels:t.labels,toString:this.toString})},ordered:function(){var t=this.options;return this.assert({type:this.deployr.RORDERED,name:this.name,value:this.value,ordered:!0,levels:t.levels,labels:t.labels,toString:this.toString})},numericMatrix:function(){return this.assert({type:this.deployr.RNUMERIC_MATRIX,name:this.name,value:this.value,toString:this.toString})},integerMatrix:function(){return this.assert({type:this.deployr.RINTEGER_MATRIX,name:this.name,value:this.value,toString:this.toString})},logicalMatrix:function(){return this.assert({type:this.deployr.RBOOLEAN_MATRIX,name:this.name,value:this.value,toString:this.toString})},characterMatrix:function(){return this.assert({type:this.deployr.RSTRING_MATRIX,name:this.name,value:this.value,toString:this.toString})},toString:function(){var t=this.options||{},e=t.levels?"[ levels = "+t.levels+"]":"",r=t.labels?"[ labels = "+t.labels+"]":"";return"[ name = "+this.name+" ] [ value = "+this.value+" ] [ type = "+this.type+" ] "+e+r}})},{"./rtypes":13,"./selfish":14}],12:[function(t,e,r){function o(t,e,r,o){var i;if(s.isObject(e)){if(i=e,!i.type!==t)throw new Error('IllegalArgumentError:Expecting "'+t+'" but found "'+i.type+'"')}else i=a["new"](e,r,o)[t]();return i}var i=t("./selfish").Base,n=t("./rtypes"),s=t("./lang"),a=t("./rinput");e.exports=i.extend(n,{numeric:function(t,e){return this.inputs.push(o(this.deployr.RNUMERIC,t,e)),this},integer:function(t,e){return this.inputs.push(o(this.deployr.RINTEGER,t,e)),this},logical:function(t,e){return this.inputs.push(o(this.deployr.RBOOLEAN,t,e)),this},character:function(t,e){return this.inputs.push(o(this.deployr.RSTRING,t,e)),this},date:function(t,e){return this.inputs.push(o(this.deployr.RDATE,t,e)),this},posixct:function(t,e){return this.inputs.push(o(this.deployr.RPOSIX_DATE,t,e)),this},numericVector:function(t,e){return this.inputs.push(o(this.deployr.RNUMERIC_VECTOR,t,e)),this},integerVector:function(t,e){return this.inputs.push(o(this.deployr.RINTEGER_VECTOR,t,e)),this},logicalVector:function(t,e){return this.inputs.push(o(this.deployr.RBOOLEAN_VECTOR,t,e)),this},characterVector:function(t,e){return this.inputs.push(o(this.deployr.RSTRING_VECTOR,t,e)),this},dateVector:function(t,e){return this.inputs.push(o(this.deployr.RDATE_VECTOR,t,e)),this},posixctVector:function(t,e){return this.inputs.push(o(this.deployr.RPOSIX_DATE_VECTOR,t,e)),this},list:function(t,e){return this.inputs.push(o(this.deployr.RLIST,t,e)),this},dataframe:function(t,e){return this.inputs.push(o(this.deployr.RDATAFRAME,t,e)),this},factor:function(t,e,r,i){var n={levels:r,labels:i};return this.inputs.push(o(this.deployr.RFACTOR,t,e,n)),this},ordered:function(t,e,r,i){var n={levels:r,labels:i};return this.inputs.push(o(this.deployr.RORDERED,t,e,n)),this},numericMatrix:function(t,e){return this.inputs.push(o(this.deployr.RNUMERIC_MATRIX,t,e)),this},integerMatrix:function(t,e){return this.inputs.push(o(this.deployr.RINTEGER_MATRIX,t,e)),this},logicalMatrix:function(t,e){return this.inputs.push(o(this.deployr.RBOOLEAN_MATRIX,t,e)),this},characterMatrix:function(t,e){return this.inputs.push(o(this.deployr.RSTRING_MATRIX,t,e)),this}})},{"./lang":7,"./rinput":11,"./rtypes":13,"./selfish":14}],13:[function(t,e,r){var o=t("./selfish").Base,i=t("./lang"),n={};e.exports=o.extend({r:{PRIMITIVE:"primitive",DATAFRAME:"dataframe",LIST:"list",MATRIX:"matrix",DATE:"date",FACTOR:"factor",VECTOR:"vector"},deployr:{RBOOLEAN:"logical",RNUMERIC:"numeric",RINTEGER:"integer",RSTRING:"character",RDATE:"date",RPOSIX_DATE:"posixct",RBOOLEAN_VECTOR:"logicalVector",RNUMERIC_VECTOR:"numericVector",RINTEGER_VECTOR:"integerVector",RSTRING_VECTOR:"characterVector",RDATE_VECTOR:"dateVector",RPOSIX_DATE_VECTOR:"posixctVector",RLIST:"list",RDATAFRAME:"dataframe",RFACTOR:"factor",RORDERED:"ordered",RBOOLEAN_MATRIX:"logicalMatrix",RNUMERIC_MATRIX:"numericMatrix",RINTEGER_MATRIX:"integerMatrix",RSTRING_MATRIX:"characterMatrix"},isDate:function(t){return t===this.deployr.RDATE||t===this.deployr.RPOSIX_DATE||t===this.deployr.RDATE_VECTOR||t===this.deployr.RPOSIX_DATE_VECTOR||t===this.r.DATE},deployrToR:function(t){var e=this.deployr,r=this.r;return n[t]||(n[e.RBOOLEAN]=r.PRIMITIVE,n[e.RNUMERIC]=r.PRIMITIVE,n[e.RINTEGER]=r.PRIMITIVE,n[e.RSTRING]=r.PRIMITIVE,n[e.RDATE]=r.DATE,n[e.RPOSIX_DATE]=r.DATE,n[e.RBOOLEAN_VECTOR]=r.VECTOR,n[e.RNUMERIC_VECTOR]=r.VECTOR,n[e.RINTEGER_VECTOR]=r.VECTOR,n[e.RSTRING_VECTOR]=r.VECTOR,n[e.RDATE_VECTOR]=r.VECTOR,n[e.RPOSIX_DATE_VECTOR]=r.VECTOR,n[e.RLIST]=r.LIST,n[e.RDATAFRAME]=r.DATAFRAME,n[e.RFACTOR]=r.FACTOR,n[e.RORDERED]=r.FACTOR,n[e.RBOOLEAN_MATRIX]=r.MATRIX,n[e.RNUMERIC_MATRIX]=r.MATRIX,n[e.RINTEGER_MATRIX]=r.MATRIX,n[e.RSTRING_MATRIX]=r.MATRIX),n[t]},assert:function(t){var e,r=this.deployr,o=null,n=t.value;n=i.isArray(n)?n:[n];for(var s=0;s<n.length;s++){var a=n[s];switch(t.type){case r.RNUMERIC:case r.RNUMERIC_VECTOR:case r.RINTEGER:case r.RINTEGER_VECTOR:e=i.isNumber;break;case r.RBOOLEAN:case r.RBOOLEAN_VECTOR:e=i.isBoolean;break;case r.RSTRING:case r.RSTRING_VECTOR:e=i.isString;break;case r.RDATE:case r.RPOSIX_DATE:case r.RDATE_VECTOR:case r.RPOSIX_DATE_VECTOR:e=i.isDate;break;case r.RFACTOR:case r.RORDERED:case r.RDATAFRAME:case r.RINTEGER_MATRIX:case r.RBOOLEAN_MATRIX:case r.RSTRING_MATRIX:e=o}if(e&&!e(a))throw new Error('RInputFormatError: "'+a+'" is not a valid "'+t.type+'" type for input "'+t.name+'"')}return t}})},{"./lang":7,"./selfish":14}],14:[function(e,r,o){!("function"!=typeof t?function(t){t(null,"undefined"!=typeof o?o:window)}:t)(function(t,e){"use strict";e.Base=Object.freeze(Object.create(Object.prototype,{"new":{value:function(){var t=Object.create(this);return t.initialize.apply(t,arguments),t}},initialize:{value:function(){}},merge:{value:function(){var t={};return Array.prototype.forEach.call(arguments,function(e){Object.getOwnPropertyNames(e).forEach(function(r){t[r]=Object.getOwnPropertyDescriptor(e,r)})}),Object.defineProperties(this,t),this}},extend:{value:function(){return Object.freeze(this.merge.apply(Object.create(this),arguments))}}}))})},{}],15:[function(t,e,r){var o=t("./lang"),i=r.get=function(t,e){function r(t,e,o){for(var i in t){var n=e.apply(this,[i,t[i],o]);if(n)return n;t[i]instanceof Object&&!(t[i]instanceof Array)&&r(t[i],e,i)}}function i(t,e){var o={};return r(t,function(t,r,i){return t===e?o=r:null}),o}function n(t){for(var e in t)if(t.hasOwnProperty(e))return t;return o.isObject(t)?null:t}return n(i(t,e))},n=r.inArray=function(t,e,r){var o,i=t.length;for(o=0;i>o;o++)if(r){if(t[o][r]===e)return t[o]}else if(t[o]===e)return t[o];return null};r.merge=function(t,e){t&&"object"==typeof t||(t={}),e&&"object"==typeof e||(e={});for(var r in e)t[r]=e[r];return t},r.workspace=function(t,e){var r=i(t,"workspace");return r?e?n(r.objects,e,"name"):r.objects||r.object:null},r.signature=function(){var t,e=Array.prototype.slice.call(arguments[0],0),r=e.length,i=!1,n={};if(1===r&&o.isObject(e[0]))n=e[0],t=n.project?"/r/project/execute/script":"/r/repository/script/execute";else if(1===r&&o.isString(e[0]))e=e[0].split("/"),t="/r/repository/script/execute",n={author:e[1],directory:e[2],filename:e[3]};else if(2===r){var s=e[1];t=s?"/r/project/execute/script":"/r/repository/script/execute",e=e[0].split("/"),n={project:s,author:e[1],directory:e[2],filename:e[3]}}else r>2&&(n={author:e[2],directory:e[1],filename:e[0]});return n.project&&o.isBoolean(n.project)&&(delete n.project,i=!0),{api:t,opts:n,create:i}}},{"./lang":7}],16:[function(t,e,r){},{}],17:[function(t,e,r){function o(){if(!a){a=!0;for(var t,e=s.length;e;){t=s,s=[];for(var r=-1;++r<e;)t[r]();e=s.length}a=!1}}function i(){}var n=e.exports={},s=[],a=!1;n.nextTick=function(t){s.push(t),a||setTimeout(o,0)},n.title="browser",n.browser=!0,n.env={},n.argv=[],n.version="",n.versions={},n.on=i,n.addListener=i,n.once=i,n.off=i,n.removeListener=i,n.removeAllListeners=i,n.emit=i,n.binding=function(t){throw new Error("process.binding is not supported")},n.cwd=function(){return"/"},n.chdir=function(t){throw new Error("process.chdir is not supported")},n.umask=function(){return 0}},{}],18:[function(t,e,r){(function(t){!function(r){"use strict";function o(t){p(function(){throw t})}function i(t){return this.then(t,r)}function n(t){return this.then(r,t)}function s(t,e){return this.then(function(e){return h(t)?t.apply(null,f(e)?e:[e]):T.onlyFuncs?e:t},e||r)}function a(t){function e(){t()}return this.then(e,e),this}function c(t){return this.then(function(e){return h(t)?t.apply(null,f(e)?e.splice(0,0,void 0)&&e:[void 0,e]):T.onlyFuncs?e:t},function(e){return t(e)})}function u(t){return this.then(r,t?function(e){throw t(e),e}:o)}function l(t,e){var r=m(t);if(1===r.length&&f(r[0])){if(!r[0].length)return T.fulfilled([]);r=r[0]}var o=[],i=T(),n=r.length;if(n)for(var s=(function(t){r[t]=T.promisify(r[t]),r[t].then(function(s){t in o||(o[t]=e?r[t]:s,--n||i.resolve(o))},function(s){t in o||(e?(o[t]=r[t],--n||i.resolve(o)):i.reject(s))})}),a=0,c=n;c>a;a++)s(a);else i.resolve(o);return i.promise}var p,h=function(t){return"function"==typeof t},f=function(t){return Array.isArray?Array.isArray(t):t instanceof Array},d=function(t){return!(!t||!(typeof t).match(/function|object/))},y=function(t){return t===!1||t===r||null===t},m=function(t,e){return[].slice.call(t,e)},v="undefined",R=typeof TypeError===v?Error:TypeError;if(typeof t!==v&&t.nextTick)p=t.nextTick;else if(typeof MessageChannel!==v){var g=new MessageChannel,j=[];g.port1.onmessage=function(){j.length&&j.shift()()},p=function(t){j.push(t),g.port2.postMessage(0)}}else p=function(t){setTimeout(t,0)};var T=function(t){function e(){if(0!==v){var t,e=g,r=0,o=e.length,i=~v?0:1;for(g=[];o>r;r++)(t=e[r][i])&&t(f)}}function o(t){function r(t){return function(e){return i?void 0:(i=!0,t(e))}}var i=!1;if(v)return this;try{var n=d(t)&&t.then;if(h(n)){if(t===j)throw new R("Promise can't resolve itself");return n.call(t,r(o),r(l)),this}}catch(s){return r(l)(s),this}return m(function(){f=t,v=1,e()}),this}function l(t){return v||m(function(){try{throw t}catch(r){f=r}v=-1,e()}),this}var f,m=(r!==t?t:T.alwaysAsync)?p:function(t){t()},v=0,g=[],j={then:function(t,r){var o=T();return g.push([function(e){try{o.resolve(y(t)?e:h(t)?t(e):T.onlyFuncs?e:t)}catch(r){o.reject(r)}},function(t){if((y(r)||!h(r)&&T.onlyFuncs)&&o.reject(t),r)try{o.resolve(h(r)?r(t):r)}catch(e){o.reject(e)}}]),0!==v&&m(e),o.promise},success:i,error:n,otherwise:n,apply:s,spread:s,ensure:a,nodify:c,rethrow:u,isPending:function(){return!(0!==v)},getStatus:function(){return v}};return j.toSource=j.toString=j.valueOf=function(){return f===r?this:f},{promise:j,resolve:o,fulfill:o,reject:l}};T.deferred=T.defer=T,T.nextTick=p,T.alwaysAsync=!0,T.onlyFuncs=!0,T.resolved=T.fulfilled=function(t){return T(!0).resolve(t).promise},T.rejected=function(t){return T(!0).reject(t).promise},T.wait=function(t){var e=T();return setTimeout(e.resolve,t||0),e.promise},T.delay=function(t,e){var r=T();return setTimeout(function(){try{r.resolve(t.apply(null))}catch(e){r.reject(e)}},e||0),r.promise},T.promisify=function(t){return t&&h(t.then)?t:T.resolved(t)},T.all=function(){return l(arguments,!1)},T.resolveAll=function(){return l(arguments,!0)},T.nodeCapsule=function(t,e){return e||(e=t,t=void 0),function(){var r=T(),o=m(arguments);o.push(function(t,e){t?r.reject(t):r.resolve(arguments.length>2?m(arguments,1):e)});try{e.apply(t,o)}catch(i){r.reject(i)}return r.promise}},typeof window!==v&&(window.D=T),typeof e!==v&&e.exports&&(e.exports=T)}()}).call(this,t("_process"))},{_process:17}],19:[function(t,e,r){function o(){}function i(t){var e={}.toString.call(t);switch(e){case"[object File]":case"[object Blob]":case"[object FormData]":return!0;default:return!1}}function n(){if(v.XMLHttpRequest&&("file:"!=v.location.protocol||!v.ActiveXObject))return new XMLHttpRequest;try{return new ActiveXObject("Microsoft.XMLHTTP")}catch(t){}try{return new ActiveXObject("Msxml2.XMLHTTP.6.0")}catch(t){}try{return new ActiveXObject("Msxml2.XMLHTTP.3.0")}catch(t){}try{return new ActiveXObject("Msxml2.XMLHTTP")}catch(t){}return!1}function s(t){return t===Object(t)}function a(t){if(!s(t))return t;var e=[];for(var r in t)null!=t[r]&&e.push(encodeURIComponent(r)+"="+encodeURIComponent(t[r]));return e.join("&")}function c(t){for(var e,r,o={},i=t.split("&"),n=0,s=i.length;s>n;++n)r=i[n],e=r.split("="),o[decodeURIComponent(e[0])]=decodeURIComponent(e[1]);return o}function u(t){var e,r,o,i,n=t.split(/\r?\n/),s={};n.pop();for(var a=0,c=n.length;c>a;++a)r=n[a],e=r.indexOf(":"),o=r.slice(0,e).toLowerCase(),i=R(r.slice(e+1)),s[o]=i;return s}function l(t){return t.split(/ *; */).shift()}function p(t){return m(t.split(/ *; */),function(t,e){var r=e.split(/ *= */),o=r.shift(),i=r.shift();return o&&i&&(t[o]=i),t},{})}function h(t,e){e=e||{},this.req=t,this.xhr=this.req.xhr,this.text="HEAD"!=this.req.method?this.xhr.responseText:null,this.setStatusProperties(this.xhr.status),this.header=this.headers=u(this.xhr.getAllResponseHeaders()),this.header["content-type"]=this.xhr.getResponseHeader("content-type"),this.setHeaderProperties(this.header),this.body="HEAD"!=this.req.method?this.parseBody(this.text):null}function f(t,e){var r=this;y.call(this),this._query=this._query||[],this.method=t,this.url=e,this.header={},this._header={},this.on("end",function(){var t=null,e=null;try{e=new h(r)}catch(o){t=new Error("Parser is unable to parse the response"),t.parse=!0,t.original=o}r.callback(t,e)})}function d(t,e){return"function"==typeof e?new f("GET",t).end(e):1==arguments.length?new f("GET",t):new f(t,e)}var y=t("emitter"),m=t("reduce"),v="undefined"==typeof window?this:window,R="".trim?function(t){return t.trim()}:function(t){return t.replace(/(^\s*|\s*$)/g,"")};d.serializeObject=a,d.parseString=c,d.types={html:"text/html",json:"application/json",xml:"application/xml",urlencoded:"application/x-www-form-urlencoded",form:"application/x-www-form-urlencoded","form-data":"application/x-www-form-urlencoded"},d.serialize={"application/x-www-form-urlencoded":a,"application/json":JSON.stringify},d.parse={"application/x-www-form-urlencoded":c,"application/json":JSON.parse},h.prototype.get=function(t){return this.header[t.toLowerCase()]},h.prototype.setHeaderProperties=function(t){var e=this.header["content-type"]||"";this.type=l(e);var r=p(e);for(var o in r)this[o]=r[o]},h.prototype.parseBody=function(t){var e=d.parse[this.type];return e&&t&&t.length?e(t):null},h.prototype.setStatusProperties=function(t){var e=t/100|0;this.status=t,this.statusType=e,this.info=1==e,this.ok=2==e,this.clientError=4==e,this.serverError=5==e,this.error=4==e||5==e?this.toError():!1,this.accepted=202==t,this.noContent=204==t||1223==t,this.badRequest=400==t,this.unauthorized=401==t,this.notAcceptable=406==t,this.notFound=404==t,this.forbidden=403==t},h.prototype.toError=function(){var t=this.req,e=t.method,r=t.url,o="cannot "+e+" "+r+" ("+this.status+")",i=new Error(o);return i.status=this.status,i.method=e,i.url=r,i},d.Response=h,y(f.prototype),f.prototype.use=function(t){return t(this),this},f.prototype.timeout=function(t){return this._timeout=t,this},f.prototype.clearTimeout=function(){return this._timeout=0,clearTimeout(this._timer),this},f.prototype.abort=function(){return this.aborted?void 0:(this.aborted=!0,this.xhr.abort(),this.clearTimeout(),this.emit("abort"),this)},f.prototype.set=function(t,e){if(s(t)){for(var r in t)this.set(r,t[r]);return this}return this._header[t.toLowerCase()]=e,this.header[t]=e,this},f.prototype.unset=function(t){return delete this._header[t.toLowerCase()],delete this.header[t],this},f.prototype.getHeader=function(t){return this._header[t.toLowerCase()]},f.prototype.type=function(t){return this.set("Content-Type",d.types[t]||t),this},f.prototype.accept=function(t){return this.set("Accept",d.types[t]||t),this},f.prototype.auth=function(t,e){var r=btoa(t+":"+e);return this.set("Authorization","Basic "+r),this},f.prototype.query=function(t){return"string"!=typeof t&&(t=a(t)),t&&this._query.push(t),this},f.prototype.field=function(t,e){return this._formData||(this._formData=new FormData),this._formData.append(t,e),this},f.prototype.attach=function(t,e,r){return this._formData||(this._formData=new FormData),this._formData.append(t,e,r),this},f.prototype.send=function(t){var e=s(t),r=this.getHeader("Content-Type");if(e&&s(this._data))for(var o in t)this._data[o]=t[o];else"string"==typeof t?(r||this.type("form"),r=this.getHeader("Content-Type"),this._data="application/x-www-form-urlencoded"==r?this._data?this._data+"&"+t:t:(this._data||"")+t):this._data=t;return e?(r||this.type("json"),this):this},f.prototype.callback=function(t,e){var r=this._callback;return this.clearTimeout(),2==r.length?r(t,e):t?this.emit("error",t):void r(e)},f.prototype.crossDomainError=function(){var t=new Error("Origin is not allowed by Access-Control-Allow-Origin");t.crossDomain=!0,this.callback(t)},f.prototype.timeoutError=function(){var t=this._timeout,e=new Error("timeout of "+t+"ms exceeded");e.timeout=t,this.callback(e)},f.prototype.withCredentials=function(){return this._withCredentials=!0,this},f.prototype.end=function(t){var e=this,r=this.xhr=n(),s=this._query.join("&"),a=this._timeout,c=this._formData||this._data;if(this._callback=t||o,r.onreadystatechange=function(){return 4==r.readyState?0==r.status?e.aborted?e.timeoutError():e.crossDomainError():void e.emit("end"):void 0},r.upload&&(r.upload.onprogress=function(t){t.percent=t.loaded/t.total*100,e.emit("progress",t)}),a&&!this._timer&&(this._timer=setTimeout(function(){e.abort()},a)),s&&(s=d.serializeObject(s),this.url+=~this.url.indexOf("?")?"&"+s:"?"+s),r.open(this.method,this.url,!0),this._withCredentials&&(r.withCredentials=!0),"GET"!=this.method&&"HEAD"!=this.method&&"string"!=typeof c&&!i(c)){var u=d.serialize[this.getHeader("Content-Type")];u&&(c=u(c))}for(var l in this.header)null!=this.header[l]&&r.setRequestHeader(l,this.header[l]);return this.emit("request",this),r.send(c),this},d.Request=f,d.get=function(t,e,r){var o=d("GET",t);return"function"==typeof e&&(r=e,e=null),e&&o.query(e),r&&o.end(r),o},d.head=function(t,e,r){var o=d("HEAD",t);return"function"==typeof e&&(r=e,e=null),e&&o.send(e),r&&o.end(r),o},d.del=function(t,e){var r=d("DELETE",t);return e&&r.end(e),r},d.patch=function(t,e,r){var o=d("PATCH",t);return"function"==typeof e&&(r=e,e=null),e&&o.send(e),r&&o.end(r),o},d.post=function(t,e,r){var o=d("POST",t);return"function"==typeof e&&(r=e,e=null),e&&o.send(e),r&&o.end(r),o},d.put=function(t,e,r){var o=d("PUT",t);return"function"==typeof e&&(r=e,e=null),e&&o.send(e),r&&o.end(r),o},e.exports=d},{emitter:20,reduce:21}],20:[function(t,e,r){function o(t){return t?i(t):void 0}function i(t){for(var e in o.prototype)t[e]=o.prototype[e];return t}e.exports=o,o.prototype.on=o.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks[t]=this._callbacks[t]||[]).push(e),this},o.prototype.once=function(t,e){function r(){o.off(t,r),e.apply(this,arguments)}var o=this;return this._callbacks=this._callbacks||{},r.fn=e,this.on(t,r),this},o.prototype.off=o.prototype.removeListener=o.prototype.removeAllListeners=o.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r=this._callbacks[t];if(!r)return this;if(1==arguments.length)return delete this._callbacks[t],this;for(var o,i=0;i<r.length;i++)if(o=r[i],o===e||o.fn===e){r.splice(i,1);break}return this},o.prototype.emit=function(t){this._callbacks=this._callbacks||{};var e=[].slice.call(arguments,1),r=this._callbacks[t];if(r){r=r.slice(0);for(var o=0,i=r.length;i>o;++o)r[o].apply(this,e)}return this},o.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks[t]||[]},o.prototype.hasListeners=function(t){return!!this.listeners(t).length}},{}],21:[function(t,e,r){e.exports=function(t,e,r){for(var o=0,i=t.length,n=3==arguments.length?r:t[o++];i>o;)n=e.call(null,n,t[o],++o,t);return n}},{}],22:[function(t,e,r){e.exports={name:"deployr",version:"7.4.2",description:"Simplified JavaScript client library for making requests to DeployR.",keywords:["deployr","deployr.io","ajax","R","api","simple"],author:"DeployR - Revolution Analytics Inc.",contributors:["Sean Wells"],repository:{type:"git",url:"git://github.com/deployr/js-client-library.git"},homepage:"http://deployr.revolutionanalytics.com/documents/dev/client-jsdoc",scripts:{start:"gulp start",build:"gulp"},devDependencies:{browserify:"^9.0.3",gulp:"^3.8.11","gulp-connect":"^2.2.0","gulp-header":"^1.2.2","gulp-jshint":"^1.9.2","gulp-livereload":"^3.8.0","gulp-plumber":"^0.6.6","gulp-rename":"^1.2.2","gulp-uglify":"^1.2.0","gulp-util":"^3.0.4",tape:"^3.5.0","vinyl-source-stream":"^1.0.0"},dependencies:{"d.js":"^0.6.0",superagent:"^0.21.0",ws:"^0.4.32"},main:"deployr.js",engines:{node:">= 0.10.0"},license:"Apache 2.0 License",bugs:{url:"https://github.com/deployr/js-client-library/issues"},directories:{example:"examples",test:"test"}}},{}]},{},[1])(1)});